/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_SOUND

#include "sound_buffer.h"


namespace OrxSound
{
  ObjectListDefinition(SoundBuffer);
  //////////////////
  /* SOUND-BUFFER */
  //////////////////
  SoundBuffer::SoundBuffer()
      : data(new SoundBufferData)
  {
    this->registerObject(this, SoundBuffer::_objectList);
  }
  /**
   * @brief Creates a Soundbuffer out of an inputfile
   * @param fileName The name of the File
   */
  SoundBuffer::SoundBuffer(const std::string& fileName)
      : data(new SoundBufferData)
  {
    this->registerObject(this, SoundBuffer::_objectList);
    this->load(fileName);
  }

  SoundBuffer::SoundBuffer(const SoundBuffer& buffer)
      : data(buffer.data)
  {
    this->registerObject(this, SoundBuffer::_objectList);
  }

  SoundBuffer::SoundBuffer(const SoundBufferData::Pointer& dataPointer)
      : data(dataPointer)
  {
    this->registerObject(this, SoundBuffer::_objectList);
  };

  SoundBuffer::~SoundBuffer()
  {
  }

}
